package examples.hibernate.domain;

import javax.persistence.*;

@Entity
public class Engine {
    /** 
     * Unique identifier.
     */
    @SuppressWarnings("unused")
    @Id @GeneratedValue(strategy=GenerationType.AUTO)
    private Long id;

    /**
     * Object version number.  
     * Necessary for the optimistic policy for concurrency control
     */
    @SuppressWarnings("unused")
    @Version
    private Long objVersion;    

    private String manufacturer;
    
    private Airplane airplane;               // one-to-one bidirectional association
    
    protected Engine() {}
    
    public Engine(String manufacturer, Airplane airplane) {
	setManufacturer(manufacturer);
	setAirplane(airplane);
    }

    public String getManufacturer() {
	return manufacturer;
    }
    
    public void setManufacturer(String manufacturer) {
	this.manufacturer = manufacturer;
    }

    public Airplane getAirplane() {
	return airplane;
    }
    
    protected void setAirplane(Airplane airplane) {
	this.airplane = airplane;
    }
    
    public String toString() {
	StringBuilder sb = new StringBuilder("\t\tEngine manufacturer: ")
		.append(manufacturer);
	
	return sb.toString();
    }

}
